// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'OrtusShellSearch.pas' rev: 5.00

#ifndef OrtusShellSearchHPP
#define OrtusShellSearchHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <OrtusShellSearchResultListView.hpp>	// Pascal unit
#include <OrtusShellGlobal.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <TypInfo.hpp>	// Pascal unit
#include <ActiveX.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Masks.hpp>	// Pascal unit
#include <ShlObj.hpp>	// Pascal unit
#include <ShellAPI.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Ortusshellsearch
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TOrtusShellSearchFileProcessEvent)(System::TObject* Sender, const 
	AnsiString FileName);

typedef void __fastcall (__closure *TOrtusShellSearchFileFoundEvent)(System::TObject* Sender, const 
	AnsiString FileName);

typedef void __fastcall (__closure *TOrtusShellSearchFolderProcessEvent)(System::TObject* Sender, const 
	AnsiString FolderName);

class DELPHICLASS TOrtusShellSearchThread;
class PASCALIMPLEMENTATION TOrtusShellSearchThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
private:
	AnsiString FFolder;
	AnsiString FLastFileName;
	AnsiString FLastFolderName;
	AnsiString FMasks;
	bool FRecursive;
	bool FActive;
	Classes::TThreadMethod FFileProcessEvent;
	Classes::TThreadMethod FFileFoundEvent;
	Classes::TThreadMethod FFolderProcessEvent;
	Classes::TThreadMethod FCompletedEvent;
	
protected:
	virtual void __fastcall Execute(void);
	
public:
	__fastcall TOrtusShellSearchThread(Classes::TThreadMethod FileProcessEvent, Classes::TThreadMethod 
		FileFoundEvent, Classes::TThreadMethod FolderProcessEvent, Classes::TThreadMethod CompletedEvent);
		
	void __fastcall Start(void);
	void __fastcall Stop(void);
	__property AnsiString Folder = {read=FFolder, write=FFolder};
	__property AnsiString LastFileName = {read=FLastFileName};
	__property AnsiString LastFolderName = {read=FLastFolderName};
	__property AnsiString Masks = {read=FMasks, write=FMasks};
	__property bool Recursive = {read=FRecursive, write=FRecursive, nodefault};
public:
	#pragma option push -w-inl
	/* TThread.Destroy */ inline __fastcall virtual ~TOrtusShellSearchThread(void) { }
	#pragma option pop
	
};


class DELPHICLASS TOrtusShellSearch;
class PASCALIMPLEMENTATION TOrtusShellSearch : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FAbout;
	AnsiString FFolder;
	Ortusshellsearchresultlistview::TOrtusShellSearchResultListView* FListView;
	AnsiString FMasks;
	bool FRecursive;
	TOrtusShellSearchFileProcessEvent FOnFileProcess;
	TOrtusShellSearchFileFoundEvent FOnFileFound;
	TOrtusShellSearchFolderProcessEvent FOnFolderProcess;
	Classes::TNotifyEvent FOnCompleted;
	TOrtusShellSearchThread* ScanThread;
	void __fastcall SetFolder(const AnsiString Value);
	void __fastcall SetListView(Ortusshellsearchresultlistview::TOrtusShellSearchResultListView* Value)
		;
	void __fastcall SetMasks(const AnsiString Value);
	void __fastcall SetRecursive(bool Value);
	void __fastcall ThreadFileProcessEvent(void);
	void __fastcall ThreadFileFoundEvent(void);
	void __fastcall ThreadFolderProcessEvent(void);
	void __fastcall ThreadCompletedEvent(void);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall Notification(Classes::TComponent* Component, Classes::TOperation Operation)
		;
	void __fastcall DoFileProcess(void);
	void __fastcall DoFileFound(void);
	void __fastcall DoFolderProcess(void);
	void __fastcall DoCompleted(void);
	
public:
	__fastcall virtual TOrtusShellSearch(Classes::TComponent* Owner);
	__fastcall virtual ~TOrtusShellSearch(void);
	void __fastcall Start(void);
	void __fastcall Stop(void);
	
__published:
	__property AnsiString Folder = {read=FFolder, write=SetFolder};
	__property Ortusshellsearchresultlistview::TOrtusShellSearchResultListView* ListView = {read=FListView
		, write=SetListView};
	__property AnsiString Masks = {read=FMasks, write=SetMasks};
	__property bool Recursive = {read=FRecursive, write=SetRecursive, default=1};
	__property TOrtusShellSearchFileProcessEvent OnFileProcess = {read=FOnFileProcess, write=FOnFileProcess
		};
	__property TOrtusShellSearchFileFoundEvent OnFileFound = {read=FOnFileFound, write=FOnFileFound};
	__property TOrtusShellSearchFolderProcessEvent OnFolderProcess = {read=FOnFolderProcess, write=FOnFolderProcess
		};
	__property Classes::TNotifyEvent OnCompleted = {read=FOnCompleted, write=FOnCompleted};
	__property AnsiString About = {read=FAbout, write=FAbout};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Ortusshellsearch */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Ortusshellsearch;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// OrtusShellSearch
